// Compiled by ClojureScript 1.9.293 {:target :nodejs}
goog.provide('angular_template_type_checker.core');
goog.require('cljs.core');
goog.require('hickory.zip');
goog.require('angular_template_type_checker.typescript');
goog.require('angular_template_type_checker.templates');
goog.require('cljs.nodejs');
goog.require('instaparse.core');
goog.require('angular_template_type_checker.hickory');
goog.require('cljs.spec');
goog.require('angular_template_type_checker.specs');
goog.require('clojure.string');
goog.require('hickory.core');
DOMParser = cljs.nodejs.require.call(null,"xmldom").DOMParser;
cljs.nodejs.enable_util_print_BANG_.call(null);
angular_template_type_checker.core.glob = cljs.nodejs.require.call(null,"glob");
angular_template_type_checker.core.fs = cljs.nodejs.require.call(null,"fs");
angular_template_type_checker.core.command_line_args = cljs.nodejs.require.call(null,"command-line-args");
angular_template_type_checker.core.getUsage = cljs.nodejs.require.call(null,"command-line-usage");
angular_template_type_checker.core.get_file_contents = (function angular_template_type_checker$core$get_file_contents(glob_pattern){
return (new Promise((function (res,rej){
return angular_template_type_checker.core.glob.call(null,glob_pattern,(function (err,files){
if(cljs.core.truth_(err)){
rej.call(null);
} else {
res.call(null,files);
}

var seq__28984 = cljs.core.seq.call(null,files);
var chunk__28985 = null;
var count__28986 = (0);
var i__28987 = (0);
while(true){
if((i__28987 < count__28986)){
var file = cljs.core._nth.call(null,chunk__28985,i__28987);

var G__28988 = seq__28984;
var G__28989 = chunk__28985;
var G__28990 = count__28986;
var G__28991 = (i__28987 + (1));
seq__28984 = G__28988;
chunk__28985 = G__28989;
count__28986 = G__28990;
i__28987 = G__28991;
continue;
} else {
var temp__6753__auto__ = cljs.core.seq.call(null,seq__28984);
if(temp__6753__auto__){
var seq__28984__$1 = temp__6753__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__28984__$1)){
var c__21520__auto__ = cljs.core.chunk_first.call(null,seq__28984__$1);
var G__28992 = cljs.core.chunk_rest.call(null,seq__28984__$1);
var G__28993 = c__21520__auto__;
var G__28994 = cljs.core.count.call(null,c__21520__auto__);
var G__28995 = (0);
seq__28984 = G__28992;
chunk__28985 = G__28993;
count__28986 = G__28994;
i__28987 = G__28995;
continue;
} else {
var file = cljs.core.first.call(null,seq__28984__$1);

var G__28996 = cljs.core.next.call(null,seq__28984__$1);
var G__28997 = null;
var G__28998 = (0);
var G__28999 = (0);
seq__28984 = G__28996;
chunk__28985 = G__28997;
count__28986 = G__28998;
i__28987 = G__28999;
continue;
}
} else {
return null;
}
}
break;
}
}));
}))).then((function (files){
return Promise.all(cljs.core.map.call(null,(function (p1__28979_SHARP_){
return (new Promise((function (res,rej){
return angular_template_type_checker.core.fs.readFile(p1__28979_SHARP_,"utf8",(function (err,contents){
if(cljs.core.truth_(err)){
return rej.call(null);
} else {
return res.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [contents,p1__28979_SHARP_], null));
}
}));
})));
}),files));
}));
});
angular_template_type_checker.core.check_metadata = (function angular_template_type_checker$core$check_metadata(metadata){

if((metadata == null)){
return "Could not find metadata";
} else {
var temp__6753__auto__ = cljs.spec.explain_data.call(null,angular_template_type_checker.specs.metadata_spec,metadata);
if(cljs.core.truth_(temp__6753__auto__)){
var spec_error = temp__6753__auto__;
return [cljs.core.str("Error with metadata: "),cljs.core.str(new cljs.core.Keyword("cljs.spec","problems","cljs.spec/problems",608491678).cljs$core$IFn$_invoke$arity$1(spec_error))].join('');
} else {
return null;
}
}
});
angular_template_type_checker.core.verify_template = (function angular_template_type_checker$core$verify_template(html,filename){
cljs.core.println.call(null,"verifying ",filename);

var tags = angular_template_type_checker.hickory.flatten_hickory.call(null,angular_template_type_checker.hickory.parse_html.call(null,html));
var metadata = angular_template_type_checker.templates.extract_metadata.call(null,tags);
var var_names = cljs.core.map.call(null,new cljs.core.Keyword(null,"name","name",1843675177),metadata);
var temp__6751__auto__ = angular_template_type_checker.core.check_metadata.call(null,metadata);
if(cljs.core.truth_(temp__6751__auto__)){
var error = temp__6751__auto__;
return new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [error], null);
} else {
var vec__29004 = cljs.core.juxt.call(null,cljs.core.remove,cljs.core.filter).call(null,instaparse.core.failure_QMARK_,cljs.core.mapcat.call(null,((function (temp__6751__auto__,tags,metadata,var_names){
return (function (p1__29000_SHARP_){
return angular_template_type_checker.templates.extract_expressions.call(null,p1__29000_SHARP_,var_names);
});})(temp__6751__auto__,tags,metadata,var_names))
,tags));
var correct_exprs = cljs.core.nth.call(null,vec__29004,(0),null);
var incorrect_exprs = cljs.core.nth.call(null,vec__29004,(1),null);
var typescript = angular_template_type_checker.typescript.build_typescript.call(null,metadata,correct_exprs);
var compilation_error = angular_template_type_checker.typescript.try_compile.call(null,typescript,filename);
return cljs.core.remove.call(null,cljs.core.nil_QMARK_,cljs.core.conj.call(null,incorrect_exprs,compilation_error));
}
});
angular_template_type_checker.core.verify_templates = (function angular_template_type_checker$core$verify_templates(glob_pattern){
return angular_template_type_checker.core.get_file_contents.call(null,glob_pattern).then((function (data){
return cljs.core.into.call(null,cljs.core.PersistentArrayMap.EMPTY,cljs.core.map.call(null,(function (p__29011){
var vec__29012 = p__29011;
var template_html = cljs.core.nth.call(null,vec__29012,(0),null);
var filename = cljs.core.nth.call(null,vec__29012,(1),null);
return new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [filename,angular_template_type_checker.core.verify_template.call(null,template_html,filename)], null);
}),data));
}));
});
angular_template_type_checker.core.process_results = (function angular_template_type_checker$core$process_results(results){
var errored_files = cljs.core.remove.call(null,(function (p__29029){
var vec__29030 = p__29029;
var _ = cljs.core.nth.call(null,vec__29030,(0),null);
var errors = cljs.core.nth.call(null,vec__29030,(1),null);
return cljs.core.empty_QMARK_.call(null,errors);
}),results);
if(!(cljs.core.empty_QMARK_.call(null,errored_files))){
cljs.core.println.call(null,"Some templates failed the type check:\r\n");

var seq__29033_29043 = cljs.core.seq.call(null,errored_files);
var chunk__29034_29044 = null;
var count__29035_29045 = (0);
var i__29036_29046 = (0);
while(true){
if((i__29036_29046 < count__29035_29045)){
var vec__29037_29047 = cljs.core._nth.call(null,chunk__29034_29044,i__29036_29046);
var filename_29048 = cljs.core.nth.call(null,vec__29037_29047,(0),null);
var errors_29049 = cljs.core.nth.call(null,vec__29037_29047,(1),null);
cljs.core.println.call(null,filename_29048);

cljs.core.println.call(null,"------");

cljs.core.doall.call(null,cljs.core.map.call(null,cljs.core.println,errors_29049));

cljs.core.println.call(null);

var G__29050 = seq__29033_29043;
var G__29051 = chunk__29034_29044;
var G__29052 = count__29035_29045;
var G__29053 = (i__29036_29046 + (1));
seq__29033_29043 = G__29050;
chunk__29034_29044 = G__29051;
count__29035_29045 = G__29052;
i__29036_29046 = G__29053;
continue;
} else {
var temp__6753__auto___29054 = cljs.core.seq.call(null,seq__29033_29043);
if(temp__6753__auto___29054){
var seq__29033_29055__$1 = temp__6753__auto___29054;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__29033_29055__$1)){
var c__21520__auto___29056 = cljs.core.chunk_first.call(null,seq__29033_29055__$1);
var G__29057 = cljs.core.chunk_rest.call(null,seq__29033_29055__$1);
var G__29058 = c__21520__auto___29056;
var G__29059 = cljs.core.count.call(null,c__21520__auto___29056);
var G__29060 = (0);
seq__29033_29043 = G__29057;
chunk__29034_29044 = G__29058;
count__29035_29045 = G__29059;
i__29036_29046 = G__29060;
continue;
} else {
var vec__29040_29061 = cljs.core.first.call(null,seq__29033_29055__$1);
var filename_29062 = cljs.core.nth.call(null,vec__29040_29061,(0),null);
var errors_29063 = cljs.core.nth.call(null,vec__29040_29061,(1),null);
cljs.core.println.call(null,filename_29062);

cljs.core.println.call(null,"------");

cljs.core.doall.call(null,cljs.core.map.call(null,cljs.core.println,errors_29063));

cljs.core.println.call(null);

var G__29064 = cljs.core.next.call(null,seq__29033_29055__$1);
var G__29065 = null;
var G__29066 = (0);
var G__29067 = (0);
seq__29033_29043 = G__29064;
chunk__29034_29044 = G__29065;
count__29035_29045 = G__29066;
i__29036_29046 = G__29067;
continue;
}
} else {
}
}
break;
}

return false;
} else {
cljs.core.println.call(null,[cljs.core.str(cljs.core.count.call(null,results)),cljs.core.str(" files verified")].join(''));

return true;
}
});
angular_template_type_checker.core.cli_option_defs = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"name","name",1843675177),"glob",new cljs.core.Keyword(null,"alias","alias",-2039751630),"g",new cljs.core.Keyword(null,"type","type",1174270348),String,new cljs.core.Keyword(null,"defaultOption","defaultOption",1679025481),true,new cljs.core.Keyword(null,"description","description",-1428560544),"Check templates matching this glob",new cljs.core.Keyword(null,"typeLabel","typeLabel",1121377034),"[underline]{glob}"], null),new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"name","name",1843675177),"help",new cljs.core.Keyword(null,"alias","alias",-2039751630),"h",new cljs.core.Keyword(null,"type","type",1174270348),Boolean,new cljs.core.Keyword(null,"description","description",-1428560544),"Shows a help message"], null)], null);
angular_template_type_checker.core._main = (function angular_template_type_checker$core$_main(){
var map__29071 = cljs.core.js__GT_clj.call(null,angular_template_type_checker.core.command_line_args.call(null,cljs.core.clj__GT_js.call(null,angular_template_type_checker.core.cli_option_defs)),new cljs.core.Keyword(null,"keywordize-keys","keywordize-keys",1310784252),true);
var map__29071__$1 = ((((!((map__29071 == null)))?((((map__29071.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__29071.cljs$core$ISeq$)))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__29071):map__29071);
var glob = cljs.core.get.call(null,map__29071__$1,new cljs.core.Keyword(null,"glob","glob",-177534284));
var help = cljs.core.get.call(null,map__29071__$1,new cljs.core.Keyword(null,"help","help",-439233446));
if(cljs.core.truth_(help)){
return cljs.core.print.call(null,angular_template_type_checker.core.getUsage.call(null,cljs.core.clj__GT_js.call(null,new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"header","header",119441134),"ATTyC",new cljs.core.Keyword(null,"content","content",15833224),"A command line tool for checking typed angularjs templates"], null),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"header","header",119441134),"Options",new cljs.core.Keyword(null,"optionList","optionList",-1706428365),angular_template_type_checker.core.cli_option_defs], null)], null))));
} else {
return angular_template_type_checker.core.verify_templates.call(null,glob).then(angular_template_type_checker.core.process_results).then(((function (map__29071,map__29071__$1,glob,help){
return (function (p1__29068_SHARP_){
return cljs.nodejs.process.exit((cljs.core.truth_(p1__29068_SHARP_)?(0):(1)));
});})(map__29071,map__29071__$1,glob,help))
);
}
});
cljs.core._STAR_main_cli_fn_STAR_ = angular_template_type_checker.core._main;
