// Compiled by ClojureScript 1.9.293 {:target :nodejs}
goog.provide('instaparse.failure');
goog.require('cljs.core');
goog.require('instaparse.print');
/**
 * Takes an index into text, and determines the line and column info
 */
instaparse.failure.index__GT_line_column = (function instaparse$failure$index__GT_line_column(index,text){
var line = (1);
var col = (1);
var counter = (0);
while(true){
if(cljs.core._EQ_.call(null,index,counter)){
return new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"line","line",212345235),line,new cljs.core.Keyword(null,"column","column",2078222095),col], null);
} else {
if(cljs.core._EQ_.call(null,"\n",cljs.core.get.call(null,text,counter))){
var G__26219 = (line + (1));
var G__26220 = (1);
var G__26221 = (counter + (1));
line = G__26219;
col = G__26220;
counter = G__26221;
continue;
} else {
var G__26222 = line;
var G__26223 = (col + (1));
var G__26224 = (counter + (1));
line = G__26222;
col = G__26223;
counter = G__26224;
continue;

}
}
break;
}
});
instaparse.failure.get_line = (function instaparse$failure$get_line(n,text){
var chars = cljs.core.seq.call(null,clojure.string.replace.call(null,text,"\r\n","\n"));
var n__$1 = n;
while(true){
if(cljs.core.empty_QMARK_.call(null,chars)){
return "";
} else {
if(cljs.core._EQ_.call(null,n__$1,(1))){
return cljs.core.apply.call(null,cljs.core.str,cljs.core.take_while.call(null,cljs.core.complement.call(null,new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 1, ["\n",null], null), null)),chars));
} else {
if(cljs.core._EQ_.call(null,"\n",cljs.core.first.call(null,chars))){
var G__26225 = cljs.core.next.call(null,chars);
var G__26226 = (n__$1 - (1));
chars = G__26225;
n__$1 = G__26226;
continue;
} else {
var G__26227 = cljs.core.next.call(null,chars);
var G__26228 = n__$1;
chars = G__26227;
n__$1 = G__26228;
continue;

}
}
}
break;
}
});
/**
 * Creates string with caret at nth position, 1-based
 */
instaparse.failure.marker = (function instaparse$failure$marker(n){
if(cljs.core.integer_QMARK_.call(null,n)){
if((n <= (1))){
return "^";
} else {
return cljs.core.apply.call(null,cljs.core.str,cljs.core.concat.call(null,cljs.core.repeat.call(null,(n - (1))," "),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, ["^"], null)));
}
} else {
return null;
}
});
/**
 * Adds text, line, and column info to failure object.
 */
instaparse.failure.augment_failure = (function instaparse$failure$augment_failure(failure,text){
var lc = instaparse.failure.index__GT_line_column.call(null,new cljs.core.Keyword(null,"index","index",-1531685915).cljs$core$IFn$_invoke$arity$1(failure),text);
return cljs.core.merge.call(null,failure,lc,new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"text","text",-1790561697),instaparse.failure.get_line.call(null,new cljs.core.Keyword(null,"line","line",212345235).cljs$core$IFn$_invoke$arity$1(lc),text)], null));
});
/**
 * Provides special case for printing negative lookahead reasons
 */
instaparse.failure.print_reason = (function instaparse$failure$print_reason(r){
if(cljs.core.truth_(new cljs.core.Keyword(null,"NOT","NOT",-1689245341).cljs$core$IFn$_invoke$arity$1(r))){
cljs.core.print.call(null,"NOT ");

return cljs.core.print.call(null,new cljs.core.Keyword(null,"NOT","NOT",-1689245341).cljs$core$IFn$_invoke$arity$1(r));
} else {
if(cljs.core.truth_(new cljs.core.Keyword(null,"char-range","char-range",1443391389).cljs$core$IFn$_invoke$arity$1(r))){
return cljs.core.print.call(null,instaparse.print.char_range__GT_str.call(null,r));
} else {
if((r instanceof RegExp)){
return cljs.core.print.call(null,instaparse.print.regexp__GT_str.call(null,r));
} else {
return cljs.core.pr.call(null,r);

}
}
}
});
/**
 * Takes an augmented failure object and prints the error message
 */
instaparse.failure.pprint_failure = (function instaparse$failure$pprint_failure(p__26229){
var map__26240 = p__26229;
var map__26240__$1 = ((((!((map__26240 == null)))?((((map__26240.cljs$lang$protocol_mask$partition0$ & (64))) || ((cljs.core.PROTOCOL_SENTINEL === map__26240.cljs$core$ISeq$)))?true:false):false))?cljs.core.apply.call(null,cljs.core.hash_map,map__26240):map__26240);
var line = cljs.core.get.call(null,map__26240__$1,new cljs.core.Keyword(null,"line","line",212345235));
var column = cljs.core.get.call(null,map__26240__$1,new cljs.core.Keyword(null,"column","column",2078222095));
var text = cljs.core.get.call(null,map__26240__$1,new cljs.core.Keyword(null,"text","text",-1790561697));
var reason = cljs.core.get.call(null,map__26240__$1,new cljs.core.Keyword(null,"reason","reason",-2070751759));
cljs.core.println.call(null,[cljs.core.str("Parse error at line "),cljs.core.str(line),cljs.core.str(", column "),cljs.core.str(column),cljs.core.str(":")].join(''));

cljs.core.println.call(null,text);

cljs.core.println.call(null,instaparse.failure.marker.call(null,column));

var full_reasons = cljs.core.distinct.call(null,cljs.core.map.call(null,new cljs.core.Keyword(null,"expecting","expecting",-57706705),cljs.core.filter.call(null,new cljs.core.Keyword(null,"full","full",436801220),reason)));
var partial_reasons = cljs.core.distinct.call(null,cljs.core.map.call(null,new cljs.core.Keyword(null,"expecting","expecting",-57706705),cljs.core.filter.call(null,cljs.core.complement.call(null,new cljs.core.Keyword(null,"full","full",436801220)),reason)));
var total = (cljs.core.count.call(null,full_reasons) + cljs.core.count.call(null,partial_reasons));
if((total === (0))){
} else {
if(cljs.core._EQ_.call(null,(1),total)){
cljs.core.println.call(null,"Expected:");
} else {
cljs.core.println.call(null,"Expected one of:");

}
}

var seq__26242_26250 = cljs.core.seq.call(null,full_reasons);
var chunk__26243_26251 = null;
var count__26244_26252 = (0);
var i__26245_26253 = (0);
while(true){
if((i__26245_26253 < count__26244_26252)){
var r_26254 = cljs.core._nth.call(null,chunk__26243_26251,i__26245_26253);
instaparse.failure.print_reason.call(null,r_26254);

cljs.core.println.call(null," (followed by end-of-string)");

var G__26255 = seq__26242_26250;
var G__26256 = chunk__26243_26251;
var G__26257 = count__26244_26252;
var G__26258 = (i__26245_26253 + (1));
seq__26242_26250 = G__26255;
chunk__26243_26251 = G__26256;
count__26244_26252 = G__26257;
i__26245_26253 = G__26258;
continue;
} else {
var temp__6753__auto___26259 = cljs.core.seq.call(null,seq__26242_26250);
if(temp__6753__auto___26259){
var seq__26242_26260__$1 = temp__6753__auto___26259;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__26242_26260__$1)){
var c__21520__auto___26261 = cljs.core.chunk_first.call(null,seq__26242_26260__$1);
var G__26262 = cljs.core.chunk_rest.call(null,seq__26242_26260__$1);
var G__26263 = c__21520__auto___26261;
var G__26264 = cljs.core.count.call(null,c__21520__auto___26261);
var G__26265 = (0);
seq__26242_26250 = G__26262;
chunk__26243_26251 = G__26263;
count__26244_26252 = G__26264;
i__26245_26253 = G__26265;
continue;
} else {
var r_26266 = cljs.core.first.call(null,seq__26242_26260__$1);
instaparse.failure.print_reason.call(null,r_26266);

cljs.core.println.call(null," (followed by end-of-string)");

var G__26267 = cljs.core.next.call(null,seq__26242_26260__$1);
var G__26268 = null;
var G__26269 = (0);
var G__26270 = (0);
seq__26242_26250 = G__26267;
chunk__26243_26251 = G__26268;
count__26244_26252 = G__26269;
i__26245_26253 = G__26270;
continue;
}
} else {
}
}
break;
}

var seq__26246 = cljs.core.seq.call(null,partial_reasons);
var chunk__26247 = null;
var count__26248 = (0);
var i__26249 = (0);
while(true){
if((i__26249 < count__26248)){
var r = cljs.core._nth.call(null,chunk__26247,i__26249);
instaparse.failure.print_reason.call(null,r);

cljs.core.println.call(null);

var G__26271 = seq__26246;
var G__26272 = chunk__26247;
var G__26273 = count__26248;
var G__26274 = (i__26249 + (1));
seq__26246 = G__26271;
chunk__26247 = G__26272;
count__26248 = G__26273;
i__26249 = G__26274;
continue;
} else {
var temp__6753__auto__ = cljs.core.seq.call(null,seq__26246);
if(temp__6753__auto__){
var seq__26246__$1 = temp__6753__auto__;
if(cljs.core.chunked_seq_QMARK_.call(null,seq__26246__$1)){
var c__21520__auto__ = cljs.core.chunk_first.call(null,seq__26246__$1);
var G__26275 = cljs.core.chunk_rest.call(null,seq__26246__$1);
var G__26276 = c__21520__auto__;
var G__26277 = cljs.core.count.call(null,c__21520__auto__);
var G__26278 = (0);
seq__26246 = G__26275;
chunk__26247 = G__26276;
count__26248 = G__26277;
i__26249 = G__26278;
continue;
} else {
var r = cljs.core.first.call(null,seq__26246__$1);
instaparse.failure.print_reason.call(null,r);

cljs.core.println.call(null);

var G__26279 = cljs.core.next.call(null,seq__26246__$1);
var G__26280 = null;
var G__26281 = (0);
var G__26282 = (0);
seq__26246 = G__26279;
chunk__26247 = G__26280;
count__26248 = G__26281;
i__26249 = G__26282;
continue;
}
} else {
return null;
}
}
break;
}
});
